#
# Conditional build:
%bcond_without	gdiplus	# use libjpeg and libtiff instead of system GDIPLUS
#
Summary:	An image loading and scaling library - cross MinGW32 version
Summary(pl.UTF-8):	Biblioteka ładująca i skalująca obrazki - wersja skrośna MinGW32
Name:		crossmingw32-gdk-pixbuf2
Version:	2.42.10
Release:	1
License:	LGPL v2+
Group:		Development/Libraries
Source0:	https://download.gnome.org/sources/gdk-pixbuf/2.42/gdk-pixbuf-%{version}.tar.xz
# Source0-md5:	4a62f339cb1424693fba9bb7ffef8150
URL:		https://developer.gnome.org/gdk-pixbuf/
BuildRequires:	crossmingw32-gcc
BuildRequires:	crossmingw32-glib2 >= 2.56.0
BuildRequires:	crossmingw32-libpng >= 1.0
BuildRequires:	gettext-tools >= 0.19
# glib-genmarshal, glib-mkenums
BuildRequires:	glib2-devel >= 1:2.56.0
BuildRequires:	meson >= 0.55.3
BuildRequires:	ninja >= 1.5
BuildRequires:	pkgconfig >= 1:0.15
BuildRequires:	rpmbuild(macros) >= 1.736
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
%if %{without gdiplus}
BuildRequires:	crossmingw32-libjpeg
BuildRequires:	crossmingw32-libtiff
%endif
Requires:	crossmingw32-glib2 >= 2.56.0
Conflicts:	crossmingw32-gtk+2 < 2.22.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		abiver	2.10.0

%define		no_install_post_strip	1
%define		_enable_debug_packages	0

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}
# for meson 0.50+, keep __cc/__cxx as host compiler and pass %{target}-* in meson-cross.txt

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
%define		optflags	-O2
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*

%description
gdk-pixbuf is an image loading and scaling library that can be
extended by loadable modules for new image formats.

This package contains the cross version for Win32.

%description -l pl.UTF-8
gdk-pixbuf to biblioteka ładująca i skalująca obrazki, której
funkcjonalność może być rozszerzana o obsługę nowych formatów poprzez
ładowane moduły.

Ten pakiet zawiera wersję skrośną dla Win32.

%package static
Summary:	Static gdk-pixbuf library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka gdk-pixbuf (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static gdk-pixbuf library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka gdk-pixbuf (wersja skrośna MinGW32).

%package dll
Summary:	DLL gdk-pixbuf libraries for Windows
Summary(pl.UTF-8):	Biblioteki DLL gdk-pixbuf dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-glib2-dll >= 2.56.0
Requires:	wine
Conflicts:	crossmingw32-gtk+2-dll < 2.22.0

%description dll
DLL gdk-pixbuf libraries for Windows.

%description dll -l pl.UTF-8
Biblioteki DLL gdk-pixbuf dla Windows.

%prep
%setup -q -n gdk-pixbuf-%{version}

# disable loaders.cache generation
%{__sed} -i -e "/^loaders_cache/,/^loaders_dep/ d" gdk-pixbuf/meson.build
# disable tests and thumbnailer (unwanted, generates files using built library/binary)
%{__sed} -i -e "/^subdir('tests')/d" meson.build
%{__sed} -i -e "/^subdir('thumbnailer')/d" meson.build
# disable unused gi-docgen subproject
%{__sed} -i -e '/fallback:.*gi-docgen/d' docs/meson.build

cat > meson-cross.txt <<'EOF'
[host_machine]
system = 'windows'
cpu_family = 'x86'
cpu = 'i386'
endian='little'
[binaries]
c = '%{target}-gcc'
ar = '%{target}-ar'
windres = '%{target}-windres'
pkgconfig = 'pkg-config'
[properties]
; force gnu99 to disable __STRICT_ANSI__ and unblock fdopen() in mingw32
c_args = ['%(echo %{rpmcflags} | sed -e "s/ \+/ /g;s/ /', '/g")', '-std=gnu99']
EOF

%build
export PKG_CONFIG_LIBDIR=%{_prefix}/lib/pkgconfig
%meson build \
	--cross-file meson-cross.txt \
	-Dbuiltin_loaders="" \
	-Ddocs=false \
	-Dinstalled_tests=false \
	-Dintrospection=disabled \
	-Dman=false \
	%{?with_gdiplus:-Dnative_windows_loaders=true}

%ninja_build -C build

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -j1 -C build

install -d $RPM_BUILD_ROOT%{_dlldir}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/bin/*.dll $RPM_BUILD_ROOT%{_dlldir}

%if 0%{!?debug:1}
%{target}-strip --strip-unneeded -R.comment -R.note $RPM_BUILD_ROOT%{_dlldir}/*.dll \
	$RPM_BUILD_ROOT%{_libdir}/gdk-pixbuf-2.0/%{abiver}/loaders/*.dll
%{target}-strip -g -R.comment -R.note $RPM_BUILD_ROOT%{_libdir}/*.a
%endif

# shut up check-files
%{__rm} $RPM_BUILD_ROOT%{_bindir}/*.exe
%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/locale
%{__rm} -r $RPM_BUILD_ROOT%{_libdir}/gdk-pixbuf-2.0/%{abiver}/loaders/*.dll.a

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_libdir}/libgdk_pixbuf-2.0.dll.a
%{_includedir}/gdk-pixbuf-2.0
%{_pkgconfigdir}/gdk-pixbuf-2.0.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libgdk_pixbuf-2.0.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libgdk_pixbuf-2.0-*.dll
%dir %{_libdir}/gdk-pixbuf-2.0
%dir %{_libdir}/gdk-pixbuf-2.0/%{abiver}
%dir %{_libdir}/gdk-pixbuf-2.0/%{abiver}/loaders
%{_libdir}/gdk-pixbuf-2.0/%{abiver}/loaders/libpixbufloader-*.dll
%changelog
* Wed Oct 26 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-gdk-pixbuf2.git;a=log;h=master

* Wed Oct 26 2022 Jakub Bogusz <qboosh@pld-linux.org> e83a521
- updated to 2.42.10

* Mon Aug 15 2022 Jakub Bogusz <qboosh@pld-linux.org> 534c7ff
- updated to 2.42.9

* Sat Mar 19 2022 Jakub Bogusz <qboosh@pld-linux.org> 827eb8d
- updated to 2.42.8
- removed obsolete meson patch

* Fri Apr 09 2021 Jakub Bogusz <qboosh@pld-linux.org> a2d02fa
- updated to 2.42.6
- added meson patch (fix build with shared windows native loader module)

* Wed Mar 31 2021 Jakub Bogusz <qboosh@pld-linux.org> 65609ce
- disable debug packages

* Wed Mar 31 2021 Jakub Bogusz <qboosh@pld-linux.org> f71916c
- updated to 2.42.4

* Tue Dec 08 2020 Jakub Bogusz <qboosh@pld-linux.org> cb35c0b
- updated to 2.42.2 (fixes CVE-2020-29385)

* Tue Nov 10 2020 Jakub Bogusz <qboosh@pld-linux.org> b58eb3c
- updated to 2.42.0

* Thu Oct 10 2019 Jakub Bogusz <qboosh@pld-linux.org> aae1f21
- updated to 2.40.0

* Mon Sep 09 2019 Jakub Bogusz <qboosh@pld-linux.org> abf0e51
- updated to 2.38.2

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> f9096f4
- updated meson cross settings

* Wed Mar 27 2019 Jakub Bogusz <qboosh@pld-linux.org> ce23daa
- updated to 2.38.1

* Thu Sep 27 2018 Jakub Bogusz <qboosh@pld-linux.org> 70010bb
- macros version

* Thu Sep 27 2018 Jakub Bogusz <qboosh@pld-linux.org> 41796a3
- updated to 2.38.0, build system changed to meson
- removed outdated png-nodep,gdip patches
- no .la file, so could be problematic for use in packages using libtool - leaving on branch for now

* Wed Sep 26 2018 Jakub Bogusz <qboosh@pld-linux.org> 969f93f
- updated to 2.36.12
- force usage of native glib2 tools

* Mon Nov 27 2017 Jakub Bogusz <qboosh@pld-linux.org> ec7d369
- updated to 2.36.11

* Mon Jul 24 2017 Jakub Bogusz <qboosh@pld-linux.org> e1e3664
- updated to 2.36.7

* Tue Apr 11 2017 Jakub Bogusz <qboosh@pld-linux.org> 7e81c80
- updated to 2.36.6

* Tue Feb 14 2017 Jakub Bogusz <qboosh@pld-linux.org> 93526fe
- updated to 2.36.5

* Sat Jan 28 2017 Jakub Bogusz <qboosh@pld-linux.org> 8dbe4c4
- release 2

